// ReSharper disable InconsistentNaming
namespace MesETL.App.Services.Seq;

public class SeqConfig(string Name, bool Recycle = true, int Step = 1, long Max = 999_999_999)
{
    public string Name { get; init; } = Name;
    public bool Recycle { get; init; } = Recycle;
    public int Step { get; init; } = Step;
    public long Max { get; init; } = Max;

    public static readonly SeqConfig ItemNo = new("seq_ItemNo", true, 1, 999_999_999);
    public static readonly SeqConfig OrderModuleID = new("seq_order_module_id", false);
    public static readonly SeqConfig OrderDataID = new("seq_order_data_id", false);
    public static readonly SeqConfig OrderItemID = new("seq_order_item", false);
    public static readonly SeqConfig ProcessStepID = new("seq_step_id", false);
    public static readonly SeqConfig PackageNo = new("seq_pack_no", true, 1, 9_999_999);
    public static readonly SeqConfig PlanNo = new("seq_plan_order", true, 1, 999_999);
    public static readonly SeqConfig SimplePlanNo = new("seq_simple_plan_order", true, 1, 999_999);

    // 下面这些类型的流水号在BaseService添加实体时进行生成
    public static readonly SeqConfig MachineID = new("seq_machine_id", false);
    public static readonly SeqConfig OrderBlockPlanID = new("seq_order_block_plan_id", false);
    public static readonly SeqConfig OrderDataGoodsID = new("seq_order_data_goods_id", false);
    public static readonly SeqConfig OrderPackageID = new("seq_order_pack_id", false);
    public static readonly SeqConfig OrderProcessID = new("seq_order_process_id", false);
    public static readonly SeqConfig OrderProcessStepItemID = new("seq_order_process_step_item_id", false);
    public static readonly SeqConfig ProcessGroupID = new("seq_process_group_id", false);
    public static readonly SeqConfig ProcessInfoID = new("seq_process_info_id", false);
    public static readonly SeqConfig ProcessItemExpID = new("seq_process_item_exp_id", false);
    public static readonly SeqConfig ProcessScheduleCapacityID = new("seq_process_schedule_capacity_id", false);
    public static readonly SeqConfig ProcessStepEfficiencyID = new("seq_process_step_efficiency_id", false);
    public static readonly SeqConfig ReportTemplateID = new("seq_report_template_id", false);
    public static readonly SeqConfig SysConfigKey = new("seq_sys_config_key", false);
    public static readonly SeqConfig WorkCalendarID = new("seq_work_calendar_id", false);
    public static readonly SeqConfig WorkShiftID = new("seq_work_shift_id", false);
    public static readonly SeqConfig WorkTimeID = new("seq_work_time_id", false);
    public static readonly SeqConfig OrderPatchDetailID = new("seq_order_patch_detail_id", false);
    public static readonly SeqConfig OrderModuleExtraID = new("seq_order_module_extra_id", false);
    public static readonly SeqConfig SimplePackageID = new("seq_simple_pack_id", false);
    public static readonly SeqConfig OrderModuleItemID = new("seq_order_module_item_id", false);
    public static readonly SeqConfig OrderWaveGroupID = new("seq_order_wave_group_id", false);
}